#include <stdio.h>
#include <conio.h>

int replace_bytes(char *buf, size_t len, const char *from_str, const char *to_str)
{
	int patched = 0;
	size_t from_offset = 0;
	size_t i = 0;
	while (i < len) {
		if (buf[i] == from_str[from_offset]) {
			++from_offset;
		} else {
			from_offset = 0;
		}

		if (from_str[from_offset] == '\0') {
			for (size_t j=i-from_offset+1, k=0; j<=i; ++j, ++k) {
				if (buf[j] != to_str[k]) {
					buf[j] = to_str[k];
					++patched;
				}
			}
			from_offset = 0;
		}

		++i;
	}

	return patched;
}

int main(int argc, char* argv[])
{
	const char *output_filename = "glide2x.dll";
	const char *input_filename = (argc == 2) ? argv[1] : "glidefps.dll";

	FILE *fp = fopen(input_filename, "rb");
	fseek(fp, 0, SEEK_END);
	size_t len = ftell(fp);

	char *buf = new char[len];

	fseek(fp, 0, SEEK_SET);
	if (fread(buf, 1, len, fp) != len) {
		printf("Could not read %lu bytes from %s\n", len, input_filename);
		fclose(fp);
		delete [] buf;
		return 1;
	}

	fclose(fp);

	int patched = replace_bytes(buf, len, "glide2x", "glide2y");


	fp = fopen(output_filename, "wb");
	if (fwrite(buf, 1, len, fp) != len) {
		fclose(fp);
		unlink("glide2x.dll");
		return 1;
	}

	printf("Successfully patched %d bytes and wrote %s\n", patched, output_filename);
	fclose(fp);

	delete [] buf;

	return 0;
}

